//===========================================================================
// package
//===========================================================================
package jp.gr.java_conf.bugslife.action;

//===========================================================================
// import
//===========================================================================
import java.io.IOException;
import java.util.Locale;
import javax.servlet.*;
import javax.servlet.http.*;
import org.apache.commons.logging.*;
import org.apache.struts.action.*;
import org.apache.struts.util.*;
import org.apache.commons.beanutils.*;

import java.util.*;
import jp.gr.java_conf.bugslife.user.*;
import jp.gr.java_conf.bugslife.selections.*;
import jp.gr.java_conf.bugslife.form.*;
/**
 *<PRE>
 * 
 * SelectionChoiceActionクラス
 *
 *</PRE>
 * @version	0.0
 * @author	鰐川 正寛
 */
public final class SelectionChoiceAction extends BaseAction 
{
//===========================================================================
// attributes
//===========================================================================
	/**
	 * Log
	 */
	private Log log = LogFactory.getLog(this.getClass().getName());
//===========================================================================
// methods
//===========================================================================
	/**
	 * exevute
	 *
	 * @param mapping The ActionMapping used to select this instance
	 * @param actionForm The optional ActionForm bean for this request (if any)
	 * @param request The HTTP request we are processing
	 * @param response The HTTP response we are creating
	 *
	 * @exception Exception if business logic throws an exception
	 */
	public ActionForward doAction(ActionMapping mapping,
				 ActionForm form,
				 HttpServletRequest request,
				 HttpServletResponse response)
				throws Exception {
		/*  初期処理
		 */
		HttpSession session = getSession(request);	//sessioの取得
		UserInfo user = (UserInfo)getAttribute(session,"UserInfo");	//ログインユーザの取得
		ActionForward forward = null;
		SelectionChoiceForm myForm = (SelectionChoiceForm)form;
		
		SelectionControl sc = (SelectionControl)session.getAttribute("selectionControl");
		
		//データチェック
		ActionErrors errors = myForm.validate(mapping, request);
		if (!errors.empty()) {
			saveErrors(request, errors);
			return (new ActionForward(mapping.getInput()));
		}
		
		String action = myForm.getAction();
		
		//scへセット
		sc.setCode(myForm.getCode());		//コード
		sc.setAction(action);				//アクション
		
		//次画面の表示準備
		SelectionEditForm nextForm = new SelectionEditForm();
		nextForm.setAction(action);
		//更新の初期画面表示
		if ((action.equals("update")) ||
			(action.equals("delete")) ||
			(action.equals("view"))) {
			//対象となるSelectionを求める
			Object selection = sc.getSelection();
			//データコピー
			PropertyUtils.copyProperties(nextForm, selection);
			//attribute セット
			session.setAttribute("selection", selection);
		//addの場合
		} else {
			
			Object selection = sc.getSelection();
			//attribute セット
			session.setAttribute("selection", selection);
		}
		//attribute セット
		request.setAttribute("selectionEditForm", nextForm);
		
		//debug 
		log.debug(sc.toString());
		
		return mapping.findForward("success");
		
	}
}
